#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%global		_spldir		%{_var}/spool/%{name}
%global		_lgdir		%{_var}/log/%{name}
#-----------------------------------------------------------------------------
Name		:	nagios
Version		:	4.4.10
Release		:	17.0.10.rel%{?dist}
Summary		:	Host/service/network monitoring program

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2
URL		:	https://github.com/NagiosEnterprises/nagioscore/

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz
Patch0		:	%{name}-%{version}-parsing.patch
Patch1		:	%{name}-%{version}-ssltest-jmp.patch
Patch2		:	%{name}-%{version}-Fix-path-to-CGI-executables.patch
Patch3		:	%{name}-%{version}-Fix-installation-of-httpd-conf.d-config-file.patch

#-----------------------------------------------------------------------------
BuildRequires	:	make
BuildRequires	:	doxygen
BuildRequires	:	gcc
BuildRequires	:	gperf
BuildRequires	:	httpd
BuildRequires	:	libgd-devel
BuildRequires	:	libjpeg-turbo-devel
BuildRequires	:	libpng-devel
BuildRequires	:	net-snmp-devel
BuildRequires	:	openssl-devel
BuildRequires	:	zlib-devel

#For check purpose
BuildRequires	:	glibc-debuginfo

Requires	:	glibc
Requires	:	httpd
Requires	:	s-nail
Requires	:	php-apache
Requires	:	shadow

#-----------------------------------------------------------------------------
%description
Nagios is a program that will monitor hosts and
services on your network.  It has the ability
to send email or page alerts when a problem
arises and when a problem is resolved.
Nagios is written in C and is designed to run
under Linux (and some other *NIX variants) as
a background process, intermittently running
checks on various services that you specify.
	
	
The actual service checks are performed by
separate "plugin" programs which return the
status of the checks to Nagios. The plugins
are available at
https://github.com/nagios-plugins/nagios-plugins
	
	
This package provides the core program,
web interface, and documentation files for
Nagios. Development files are built as
a separate package.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc Changelog INSTALLING README.md
%doc UPGRADING
%license LICENSE
%attr(0750,%{name},%{name}) %config(noreplace) %{_sysconfdir}/%{name}/*.cfg
%exclude %{_sysconfdir}/%{name}/%{name}.cfg
%exclude %{_sysconfdir}/%{name}/cgi.cfg
%config(noreplace) %{_sysconfdir}/%{name}/objects/*cfg
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}.lr
%attr(0755,root,root) %{_initrddir}/%{name}
%{_bindir}/%{name}
%{_bindir}/%{name}tats
%{_libdir}/%{name}/cgi/*.cgi
%{_datadir}/%{name}/html/robots.txt
%{_datadir}/%{name}/html/*.html
%{_datadir}/%{name}/html/*.php
%{_datadir}/%{name}/html/angularjs/
%{_datadir}/%{name}/html/bootstrap*/css/*.css
%{_datadir}/%{name}/html/contexthelp/
%{_datadir}/%{name}/html/d3/
%{_datadir}/%{name}/html/includes/utils.inc.php
%{_datadir}/%{name}/html/js/*.js
%{_datadir}/%{name}/html/images/favicon.ico
%{_datadir}/%{name}/html/images/*.gif
%{_datadir}/%{name}/html/images/*.jpg
%{_datadir}/%{name}/html/images/*.png
%{_datadir}/%{name}/html/images/logos/*
%{_datadir}/%{name}/html/spin/spin.min.js
%{_datadir}/%{name}/html/stylesheets/*.css
%attr(0770,%{name},%{name}) %dir %{_spldir}
%attr(0770,%{name},%{name}) %dir %{_spldir}/archives
%attr(0770,%{name},%{name}) %dir %{_spldir}/checkresult
%attr(0770,%{name},%{name}) %dir %{_spldir}/rw
%dir %{_var}/log/%{name}

#-----------------------------------------------------------------------------
%preun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1 || :
  %{_sbindir}/chkconfig --del %{name}
  /usr/sbin/groupdel -f %{name}
  /usr/sbin/userdel -f %{name}
  (
  /bin/echo -n "%{name}-%{version}-%{release} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

%pre
getent group %{name} >/dev/null || 		\
	/usr/sbin/groupadd			\
		-r				\
		-K SYS_GID_MIN=50		\
		-K SYS_GID_MAX=99		\
		%{name}
getent passwd %{name} >/dev/null ||		\
	/usr/sbin/useradd			\
		-r				\
		-c "Nagios Server"		\
		-K SYS_UID_MIN=50		\
		-K SYS_UID_MAX=99		\
		-g %{name}			\
		-s /sbin/nologin		\
		-d %{_sysconfdir}/%{name}	\
		%{name}

rm -fr  %{_var}/log/README-%{name}-removed

%post
%{_sbindir}/usermod -a -G %{name} apache || :
if [ "$1" = 1 ]; then
  %{_sbindir}/chkconfig --add %{name}
  fi
sed -i						\
  -e"s/#LoadModule cgi_m/LoadModule cgi_m/"	\
  -e"s/#LoadModule cgid_m/LoadModule cgid_m/"	\
  /etc/httpd/httpd.conf

%{_sysconfdir}/rc.d/init.d/httpd condrestart > /dev/null 2>&1 || :
%{_sysconfdir}/rc.d/init.d/%{name} condrestart > /dev/null 2>&1 || :

%postun
%{_sysconfdir}/rc.d/init.d/httpd condrestart > /dev/null 2>&1 || :

#=============================================================================
%package		devel
Summary		:	Provides include files that Nagios-related applications may compile against

#-----------------------------------------------------------------------------
Requires	:	%{name} = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
The %{name}-devel package contains the header files
and libraries needed to develop programs that use
the '%{name} library.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{name}/*.h
%{_includedir}/%{name}/lib/*.h

#=============================================================================
%package		demo-config
Summary		:	Config files for a simple nagios configuration

#-----------------------------------------------------------------------------
Requires	:	%{name} = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		demo-config
'%{name}'  config file for a working demo setup

#-----------------------------------------------------------------------------
%files			demo-config
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.cfg
%config(noreplace) %{_sysconfdir}/%{name}/cgi.cfg
%config(noreplace) %{_sysconfdir}/%{name}/htpasswd.users
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf

#=============================================================================
%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

tar xf %{SOURCE1}

#-----------------------------------------------------------------------------
#building application
%build

autoconf -v -i -f 
./configure						\
        --prefix=%{_prefix}				\
	--sysconfdir=%{_sysconfdir}/%{name}		\
	--bindir=%{_bindir}				\
	--sbindir=%{_libdir}/%{name}/cgi		\
        --includedir=%{_includedir}			\
	--libdir=%{_libdir}				\
	--libexecdir=%{_libdir}/%{name}/plugins		\
	--localstatedir=%{_spldir}	 		\
	--mandir=%{_mandir}				\
	--datadir=%{_datadir}/%{name}/html		\
	--with-logdir=%{_lgdir}				\
	--with-checkresult-dir=%{_spldir}/checkresult	\
	--with-cgibindir=%{_libdir}/%{name}/cgi		\
	--with-cgiurl=/%{name}/cgi-bin			\
	--with-command-user=apache			\
	--with-command-group=apache			\
	--with-mail=/usr/bin/s-nail			\
	--with-nagios-user=%{name}			\
	--with-nagios-grp=%{name}			\
	--with-initdir=%{_initrddir}			\
	--with-init-type=sysv				\
	--with-template-objects				\
	--with-template-extinfo				\
	--with-perlcache				\
	--enable-event-broker 				\
	--enable-libtap					\
	--enable-ssl					\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	%{_smp_mflags}					\
	all

%{__make}						\
	%{_smp_mflags}					\
	dox

### Apparently contrib does not obey configure !
%{__make}						\
	-C contrib					\
	%{_smp_mflags}

#preseting the application password
  echo %{name} |				\
    htpasswd 					\
      -i					\
      -c htpasswd.users 			\
      %{name}admin
#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
%check
%{__make}						\
	test

#-----------------------------------------------------------------------------
#installing program
%install

%{__rm} -rf %{buildroot}
%{__make}						\
	DESTDIR=%{buildroot}				\
	INSTALL_OPTS=""					\
	INIT_OPTS=""					\
	COMMAND_OPTS=""					\
	install-unstripped				\
	install-init					\
	install-commandmode				\
	install-config

%{__install} -d -m 0755					\
	%{buildroot}%{_includedir}/%{name}/	
%{__install} -p -m 0644					\
	include/*.h					\
	%{buildroot}%{_includedir}/%{name}/

%{__mkdir} -p -m 0755					\
	%{buildroot}/%{_includedir}/%{name}/lib
%{__install} -m 0644					\
	lib/*.h						\
	%{buildroot}/%{_includedir}/%{name}/lib

%{__install} -Dp -m 0644				\
	sample-config/httpd.conf			\
	%{buildroot}%{_sysconfdir}/httpd/conf.d/%{name}.conf

%{__install} -d -m 0755 				\
	%{buildroot}%{_var}/log/%{name}

# Fix permissions - FIXME remove this when unneeded
chmod 755 %{buildroot}%{_bindir}/nagios

### FIX log-paths
sed -i								\
  -e "s|^log_file=.*|log_file=%{_lgdir}/%{name}.log|"		\
  -e "s|_archive_path=.*|_archive_path=%{_lgdir}/archive|"	\
  -e "s|^debug_file=.*|debug_file=%{_lgdir}/%{name}.debug|"	\
  -e "s|^log_rotation_method=.*|log_rotation_method=n|"		\
  -e "s|^date_format=.*|date_format=iso8601|"			\
  %{buildroot}%{_sysconfdir}/%{name}/%{name}.cfg

#using osuking init script
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} -a 							\
	%{name}-ok_addon/%{name}				\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

# Install logrotate rule
%{__mkdir_p} %{buildroot}%{_sysconfdir}/logrotate.d/
%{__cp} -a 							\
	%{name}-ok_addon/%{name}.lr				\
	%{buildroot}%{_sysconfdir}/logrotate.d/

#installing default password
%{__cp} -a 							\
	htpasswd.users 						\
	%{buildroot}%{_sysconfdir}/%{name}/

#=============================================================================
%changelog
